# 挂柯南

## 服务器配置
```js
// 安装venv
python3 -m venv venv
// 启动venv
. venv/bin/activate
// 升级pip
pip install --upgrade pip
// 安装flask...
pip install Flask
pip install requests
pip install bs4
pip install gunicorn
pip install pymongo
pip install flask_cors
// 根据依赖文件安装环境
pip install -r requirements.txt -i https://pypi.tuna.tsinghua.edu.cn/simple
// 设置全局变量
export FLASK_APP=cherry.py
export FLASK_ENV=development
// 启动临时服务
flask run --host=0.0.0.0 -p 8001
// beta
flask run --host=127.0.0.1 -p 6000
// 启动永久服务
gunicorn cherry:app -c gunicorn.conf.py
// 查看已启动服务
pstree -ap|grep gunicorn
// 关闭某服务
kill (pid)
//关闭venv
deactivate 
```

## 错误代码一览

/api/login
400：数据校验失败
510：账号或密码错误
511：请填写手机号
512：教务挂了
200：OK

/api/game/schedule/upload
400：数据校验失败
401：排名表修改失败

/api/game/schedule/get
410: 数据校验失败
411：排名表获取失败

# game
* /api/game/schedule/upload
  * data
    * nick
    * count
    * time
    * sign
* /api/game/schedule/get
  * data
    * sign